<?php
/*
 * UnifonicAuthenticateLib
 *
 * This file was automatically generated by APIMATIC v2.0 ( https://apimatic.io ).
 */

namespace UnifonicAuthenticateLib\Controllers;

use UnifonicAuthenticateLib\APIException;
use UnifonicAuthenticateLib\APIHelper;
use UnifonicAuthenticateLib\Configuration;
use UnifonicAuthenticateLib\Models;
use UnifonicAuthenticateLib\Exceptions;
use UnifonicAuthenticateLib\Http\HttpRequest;
use UnifonicAuthenticateLib\Http\HttpResponse;
use UnifonicAuthenticateLib\Http\HttpMethod;
use UnifonicAuthenticateLib\Http\HttpContext;
use UnifonicAuthenticateLib\Servers;
use Unirest\Request;

/**
 * @todo Add a general description for this controller.
 */
class VerificationsController extends BaseController
{
    /**
     * @var VerificationsController The reference to *Singleton* instance of this class
     */
    private static $instance;

    /**
     * Returns the *Singleton* instance of this class.
     * @return VerificationsController The *Singleton* instance.
     */
    public static function getInstance()
    {
        if (null === static::$instance) {
            static::$instance = new static();
        }
        
        return static::$instance;
    }

    /**
     * @todo Add general description for this endpoint
     *
     * @param string $to      Address of receiver
     * @param string $channel Channel you want to send. Possible values are `sms`, `whatsapp` & `voice`.
     * @param string $code    The code which user has entered
     * @return mixed response from the API call
     * @throws APIException Thrown if API call fails
     */
    public function createCheckVerification(
        $to,
        $channel,
        $code
    ) {

        //prepare query string for API call
        $_queryBuilder = '/services/api/v1/verifications/check';

        //validate and preprocess url
        $_queryUrl = APIHelper::cleanUrl(Configuration::getBaseUri() . $_queryBuilder);

        //prepare headers
        $_headers = array (
            'user-agent'    => BaseController::USER_AGENT,
            'Accept'        => 'application/json',
            'x-authenticate-app-id' => Configuration::$xAuthenticateAppId,
            'Authorization' => Configuration::$authorization
        );

        //prepare parameters
        $_parameters = array (
            'to'      => $to,
            'channel' => $channel,
            'code'    => $code
        );

        //call on-before Http callback
        $_httpRequest = new HttpRequest(HttpMethod::POST, $_headers, $_queryUrl, $_parameters);
        if ($this->getHttpCallBack() != null) {
            $this->getHttpCallBack()->callOnBeforeRequest($_httpRequest);
        }

        //and invoke the API call request to fetch the response
        $response = Request::post($_queryUrl, $_headers, Request\Body::Form($_parameters));

        $_httpResponse = new HttpResponse($response->code, $response->headers, $response->raw_body);
        $_httpContext = new HttpContext($_httpRequest, $_httpResponse);

        //call on-after Http callback
        if ($this->getHttpCallBack() != null) {
            $this->getHttpCallBack()->callOnAfterRequest($_httpContext);
        }

        //Error handling using HTTP status codes
        if ($response->code == 400) {
            throw new APIException('bad input parameter', $_httpContext);
        }

        //handle errors defined at the API level
        $this->validateResponse($_httpResponse, $_httpContext);

        $mapper = $this->getJsonMapper();

        return $mapper->mapClass($response->body, 'UnifonicAuthenticateLib\\Models\\Verification');
    }

    /**
     * This endpoint sends a verification code through any of channels mainly `Sms`, `Voice` & `Whatsapp`.
     * By default it sends messages to all configured channels in the Authenticate app.
     *
     * @param string $to      Address of receiver
     * @param string $channel (optional) Channel you want to use for sending verification code. Currently there are
     *                        three channels  `SMS`, `Voice` & `Whatsapp`. Their priorities can be defined in Unifonic
     *                        Authenticate configuration panel. By default it will send verification through all of
     *                        configured channels. If channel is not defined the verification code will be sent on the
     *                        basis of priority defined for each channel.
     * @param string $locale  (optional) In what language you want to send
     * @param string $length  (optional) Length of verification code
     * @return mixed response from the API call
     * @throws APIException Thrown if API call fails
     */
    public function createVerification(
        $to,
        $channel = null,
        $locale = 'en',
        $length = null
    ) {

        //prepare query string for API call
        $_queryBuilder = '/services/api/v1/verifications/start';

        //validate and preprocess url
        $_queryUrl = APIHelper::cleanUrl(Configuration::getBaseUri() . $_queryBuilder);

        //prepare headers
        $_headers = array (
            'user-agent'    => BaseController::USER_AGENT,
            'Accept'        => 'application/json',
            'x-authenticate-app-id' => Configuration::$xAuthenticateAppId,
            'Authorization' => Configuration::$authorization
        );

        //prepare parameters
        $_parameters = array (
            'to'      => $to,
            'channel' => $channel,
            'locale'  => (null != $locale) ? $locale : 'en',
            'length'  => $length
        );

        //call on-before Http callback
        $_httpRequest = new HttpRequest(HttpMethod::POST, $_headers, $_queryUrl, $_parameters);
        if ($this->getHttpCallBack() != null) {
            $this->getHttpCallBack()->callOnBeforeRequest($_httpRequest);
        }

        //and invoke the API call request to fetch the response
        $response = Request::post($_queryUrl, $_headers, Request\Body::Form($_parameters));

        $_httpResponse = new HttpResponse($response->code, $response->headers, $response->raw_body);
        $_httpContext = new HttpContext($_httpRequest, $_httpResponse);

        //call on-after Http callback
        if ($this->getHttpCallBack() != null) {
            $this->getHttpCallBack()->callOnAfterRequest($_httpContext);
        }

        //Error handling using HTTP status codes
        if ($response->code == 400) {
            throw new APIException('bad input parameter', $_httpContext);
        }

        //handle errors defined at the API level
        $this->validateResponse($_httpResponse, $_httpContext);

        $mapper = $this->getJsonMapper();

        return $mapper->mapClass($response->body, 'UnifonicAuthenticateLib\\Models\\Verification');
    }
}
